#include "stdafx.h"
#include <glut.h>
#include <math.h>
#include <stdlib.h>
#define PI 3.1415926535898
float WinWid = 600.0, WinHei = 600.0;// 
float R=200.0;
float Angle;
float cnt=0;
float xc,yc;
int p;
float rWhite[8] = {0,16,32,48,65,48,32,16};//     
float rBlack[8] = {65,48,32,16,0,16,32,48};//     

bool ChangeBlack=true, ChangeWhite=true;

void CIRCLE(float Xc, float Yc, float R, float color)//  
{
	glBegin(GL_TRIANGLE_FAN);
	float angle=0.0;
	if(color==0)glColor3f(0.0, 0.0, 0.0);
	if(color==1)glColor3f(1.0, 1.0, 1.0);
	for (int i = 0; i < 100; i++)
	{
		angle = 2*PI*i/100;
		glVertex2f(Xc+R*cos(angle),Yc+R*sin(angle));
	}
	glEnd();
}
void Draw()//   
{
	glClear(GL_COLOR_BUFFER_BIT);// 
	glPushMatrix();// 
	
	
	for(Angle=0;Angle<360;Angle+=45){//   45    200
	p=Angle/45;	
		if(ChangeWhite)//  
			{
				if(rWhite[p]<65)rWhite[p]++;
				if(rWhite[p]==65)
				{
					rBlack[p]=0;
					ChangeWhite=false;
					ChangeBlack=true;
				}
			}
	if(ChangeBlack)//  
			{
				if(rBlack[p]<65)rBlack[p]++;
				if(rBlack[p]==65)
				{
					rWhite[p]=0;
					ChangeBlack=false;
					ChangeWhite=true;
				}
			}

		xc=R*cos((Angle-cnt)*PI/180);//  
		yc=R*sin((Angle-cnt)*PI/180);//

		if(ChangeWhite)//   
		{
		CIRCLE(xc,yc,rBlack[p],0);
		CIRCLE(xc,yc,rWhite[p],1);
		}
		if(ChangeBlack)//   
		{
		CIRCLE(xc,yc,rWhite[p],1);
		CIRCLE(xc,yc,rBlack[p],0);
		}
	}
	glPopMatrix();//
	glutSwapBuffers();// 
}

void Initialize()//
{
	glClearColor(0.25, 0.25, 0.25, 0.0);// 
	glMatrixMode(GL_PROJECTION);//  
	glLoadIdentity();
	glOrtho(-WinWid/2, WinWid/2, -WinHei/2, WinHei/2, -200.0, 200.0);//  
	glMatrixMode(GL_MODELVIEW);
}
void Timer(int)// 
{
	cnt++;//
	glutPostRedisplay();
	glutTimerFunc(30, Timer, 0);
	
}

int main(int argc, char** argv)
{
	glutInit(&argc, argv);// 
	glutInitDisplayMode(GLUT_DOUBLE|GLUT_RGB);
	glutInitWindowSize(WinWid, WinHei);//  
	glutInitWindowPosition(50,50);//  
	glutCreateWindow("DEMO");// 
	glutDisplayFunc(Draw);//  
	glutTimerFunc(30, Timer, 0);//  
	Initialize();
	glutMainLoop();
	return 0;
}